hex
create bye_argv 7ed4 ,
create bye_start 7c00 ,
variable bye_size
variable bye_sector

: lockset ( locknum ... ) 0cfc0006 cogx1 drop ;
: lockclr ( locknum ... ) 0cfc0007 cogx1 drop ;

: bye
  \ Close files
  fb close-file drop
  fc close-file drop

  \ Set up the arg list
  bye_argv @ 10 + c" /bin/shell" 0a cmove
  bye_argv @ 1a + 0 c!
  bye_argv @ 10 + bye_argv @ !
  bye_argv @ 1a + bye_argv @ 4 + !
  bye_argv @ 1a + bye_argv @ 8 + !
  [char] / bye_argv @ 1b + c!
  0 bye_argv @ 1c + c!

  \ Open pshell and get sector and length
  s" /bin" cd-path
  s" pshell" 0 open-file drop
  file_sector0 @ bye_sector !
  file_length  @ bye_length !
  close-file drop

  \ Open _ploader
  s" _ploader" 0 open-file drop

  \ Stop all the cogs except this one and the SD SPI cog
  SPI_engine_cog @ 1 - 8 0 do
    dup i <> i cogid <> and if i cogstop then loop drop

  \ Clear and return all the locks
  8 0 do i lockclr i lockret loop

  \ Read the loader into memory
  bye_start @ 200 2 pick read-file drop drop drop
  close-file drop

  \ Add the memory offset to the header
  bye_start @
  8 3 do dup dup w@ bye_start @ + swap w! 2+ loop drop

  \ Add the parms to the stack
  bye_start @ 10 + 0 over !
  4 + 1 over !
  4 + bye_argv @ over !
  4 + 0 over !
  4 + bye_sector over !
  4 + bye_length over !
  f004 bye_start @ 4 + cogid coginit
;

decimal
