'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4E505350 ' PSPN

OBJ
  c : "clibsd"
  sys : "sysdefs"

PUB main(argc, argv) | cognum, parmstr, entryptr, type
  if argc <> 2
    usage
  parmstr := long[argv][1]
  cognum := byte[parmstr] - "0"
  if cognum < 0 OR cognum > 7 OR byte[parmstr][1]
    usage
  entryptr := sys#cogtable + (cognum * 24)
  type := byte[entryptr]
  ifnot type
    c.printf1(string("Process %d is not running\n"), cognum)
    c.exit(1)

  cogstop(cognum)
  if type == 1 ' SPIN
    c.free(word[entryptr+20])

  byte[entryptr] := 0

  c.exit(0)

PUB usage
  c.printf0(string("usage: kill procnum\n"))
  c.exit(1)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
