'******************************************************************************
' Copyright (c) 2011, 2012, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibsd"
  sys : "sysdefs"

DAT
  idle long 0[8]

PUB main(argc, argv) | spicog, i
  c.enter

  spicog := long[sys#spi_engine_cog] - 1

  repeat
    i := cognew(@dummy, 0)
    if i => 0 and i =< 7
      idle[i] := 1
    else
      quit

  repeat i from 0 to 7
    if i == cogid
      c.printf2(string("%d %s\n"), cogid, long[argv])
    elseif i == spicog
      c.printf1(string("%d SPI Driver\n"), spicog)
    elseif idle[i]
      c.printf1(string("%d Idle\n"), i)
      'cogstop(i)
    else
      c.printf1(string("%d Serial Driver\n"), i)

  c.exit(0)

DAT
        org  0
dummy   jmp  #dummy

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
