'******************************************************************************
' Copyright (c) 2011, 2012, 2013, Dave Hein
' See end of file for terms of use.
'******************************************************************************
CON
  _clkmode = xinput
  _xinfreq = $4e495053 ' SPIN

OBJ
  c : "clibsd"
  sys : "sysdefs"

PUB main(argc, argv) | i
  c.enter
  c.printf0(string("Rebooting\n"))
  waitcnt(cnt + clkfreq/10)
  save_sysparm
  reboot

pub save_sysparm | outfile, ptr
  outfile := c.fopen(string("/_sysparm"), string("w"))
  ifnot outfile
    c.printf0(string("Can't open /_sysparm\n"))
    return
  c.fprintf1(outfile, string("%d\n"), long[sys#unixtime])
  c.fprintf2(outfile, string("%d %d 0\n"), long[sys#timezone], long[sys#config])
  c.fprintf0(outfile, string("0 0 0\n"))
  c.fprintf0(outfile, string("GPWD /\n"))
  c.fprintf0(outfile, string("LSCRIPT_FILE /bin/_shellrc\n"))
  c.fprintf0(outfile, string("P# 0\n"))
  c.fclose(outfile)

{{
+-----------------------------------------------------------------------------+
|                       TERMS OF USE: MIT License                             |
+-----------------------------------------------------------------------------+
|Permission is hereby granted, free of charge, to any person obtaining a copy |
|of this software and associated documentation files (the "Software"), to deal|
|in the Software without restriction, including without limitation the rights |
|to use, copy, modify, merge, publish, distribute, sublicense, and/or sell    |
|copies of the Software, and to permit persons to whom the Software is        |
|furnished to do so, subject to the following conditions:                     |
|                                                                             |
|The above copyright notice and this permission notice shall be included in   |
|all copies or substantial portions of the Software.                          |
|                                                                             |
|THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR   |
|IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,     |
|FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE  |
|AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER       |
|LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,|
|OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE|
|SOFTWARE.                                                                    |
+-----------------------------------------------------------------------------+
}}
