void dfs_resolve_path(const char *fname, char *path)
{
    char *ptr;
    char *ptr1;

    if (!strcmp(fname, ".")) fname++;
    else if (!strncmp(fname, "./",2) || !strncmp(fname, ".\\",2)) fname += 2;

    if (fname[0] == '/' || fname[0] == '\\')
        strcpy(path, fname);
    else if (fname[0] == 0)
        strcpy(path, dfs_currdir);
    else
    {
        strcpy(path, dfs_currdir);
        int pathLen = strlen(path);
        if (path[pathLen-1] != '/' && path[pathLen-1] != '\\') strcat(path, "/");
        strcat(path, fname);
    }

    // Whack DOS paths to UNIX paths
    for (ptr = path;  *ptr;  ptr++)
        if (*ptr == '\\')
            *ptr = '/';

    // Process ..
    ptr = path;
    while (*ptr)
    {
        if (!strncmp(ptr, "/..", 3) && (ptr[3] == 0 || ptr[3] == '/'))
        {
            if (ptr == path)
            {
               movestr(ptr, ptr+3);
            }
            else
            {
                ptr1 = ptr - 1;
                while (ptr1 != path)
                {
                    if (*ptr1 == '/') break;
                    ptr1--;
                }
                movestr(ptr1, ptr+3);
                ptr = ptr1;
            }
        }
        else
        {
            ptr++;
            while (*ptr)
            {
               if (*ptr == '/') break;
               ptr++;
            }
        }
    }

    if (path[0] == 0) strcpy(path, "/");
}
