CON
  _clkmode = xinput
  _xinfreq = $4E505350 ' PSPN

OBJ
  ut : "unixtime"
  c : "clib_os"
  sys : "sysdefs"

con
  CYCLE0   = sys#cycle0
  SECONDS  = sys#unixtime
  TIMEZONE = sys#timezone

pub main(argc, argv) | unixtime, date, time, hour, minute, second, year, month, day, cycle, temp, tz
  tz := long[TIMEZONE]
  unixtime := long[SECONDS]
  date := ut.date(unixtime, tz)
  time := ut.time(unixtime, tz)
  year   := word[@date][1]
  month  := byte[@date][1]
  day    := byte[@date][0]
  hour   := word[@time][1]
  minute := byte[@time][1]
  second := byte[@time][0]
  c.printf0(string("******************************************************\n"))
  c.printf0(string("*                                                    *\n"))
  c.printf0(string("*             SPINIX 1.17 October 3, 2013            *\n"))
  c.printf0(string("*                                                    *\n"))
  c.printf0(string("******************************************************\n"))
  c.printf0(string("\n"))
  c.printf0(string("Current date and time: "))
  c.printf3(string("%2.2d/%2.2d/%2.2d "), year, month, day)
  c.printf3(string("%2.2d:%2.2d:%2.2d\n"),hour, minute, second)
  c.printf0(string("\n"))

